open Core


let run ezfio_filename = 
  Qputils.set_ezfio_filename ezfio_filename;
  let qmcchem_info =
      Lazy.force Qmcchem_config.qmcchem_info
  in
  let prog, argv = 
      qmcchem_info, 
    [ qmcchem_info ; ezfio_filename ]
  in
  ignore @@
    Unix.exec ~prog ~argv () 


let spec =
  let open Command.Spec in
  empty
  +> anon ("ezfio_file" %: string)

let command = 
    Command.basic_spec
    ~summary: "Display info on an EZFIO database"
    ~readme:(fun () ->
      "
Display info on an EZFIO database
      ")
    spec
    (fun ezfio_file () ->  run ezfio_file )


